﻿Type=Class
Version=2.5
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'This module displays a debug window with CUP information and some tools for debugging.
Private Sub Class_Globals
	Private fx As JFX
	Private DebugForm As Form
	Private btnStep,btnRefreshData As Button
	Private lblStep As Label
	Private lblAF,lblBC,lblDE,lblHL As Label
	Private lblAFPrime,lblBCPrime,lblDEPrime,lblHLPrime As Label
	Private lblIX,lblIY As Label
	Private lblPC,lblSP,lblIM,lblInterruptEnabled As Label
	Private lblFlags,lblFlagsPrime As Label
	Private lblOpCode,lblOpName,lblOpCodePlus1,lblOpCodePlus2 As Label
	Private txtBreakpoint As TextField
	Private btnBreakpoint As Button
	Private btnPause As Button
	Private btnRefreshScreen As Button
	Private lblInspectMemory0,lblInspectMemory1,lblInspectMemory2,lblInspectMemory3,lblInspectMemory4,lblInspectMemory5,lblInspectMemory6,lblInspectMemory7,lblInspectMemory8,lblInspectMemory9 As Label
	Private txtInspectFrom As TextField
	Private lblMemory0,lblMemory1,lblMemory2,lblMemory3,lblMemory4,lblMemory5,lblMemory6,lblMemory7,lblMemory8,lblMemory9 As Label
	Private lblI,lblR As Label
	Private InspectFrom As Int
	Private btnInterruptToggle As Button
	Public AllowInterrupt As Boolean
	Private CallingModule As Object
	Public BreakPoint As Int 
	Public ActiveBreakPoint As Boolean
End Sub

Public Sub Initialize (ModuleName As Object)
	CallingModule = ModuleName
	DebugForm.Initialize("DebugWindow",-1,-1)
	DebugForm.WindowTop = 400
	DebugForm.WindowLeft = 200
	DebugForm.SetFormStyle("UTILITY")
	DebugForm.Resizable = False	
	DebugForm.RootPane.LoadLayout("DebugWindow.fxml")
	DebugForm.Title = "ZX Spectrum Debug"
	txtInspectFrom.Text = 0
	InspectFrom = txtInspectFrom.Text
	AllowInterrupt = True
	ActiveBreakPoint = False
End Sub 

Public Sub Show
	DebugForm.Show
End Sub

Public Sub Close
	DebugForm.Close
End Sub

'If the calling module has a DebugWindow_closed sub, it will be called when the form is closed.
Public Sub DebugWindow_closed
	If SubExists (CallingModule, "DebugWindow_closed") Then
		CallSub(CallingModule, "DebugWindow_closed")
	End If
End Sub

Public Sub TogglePauseButton
	btnPause.Text = "Resume"
End Sub

Public Sub Refresh
	lblStep.Text = Z80.OpCodeCounter
	lblPC.Text = SixteenBitNumberToHex(Z80.PC_Old)
	lblSP.Text = SixteenBitNumberToHex(Z80.SP)
	lblAF.Text = EightBitNumberToHex(Z80.a) & EightBitNumberToHex(Z80.f)
	lblBC.Text = SixteenBitNumberToHex(Z80.BC)
	lblDE.Text = SixteenBitNumberToHex(Z80.DE)
	lblHL.Text = SixteenBitNumberToHex(Z80.HL)
	lblAFPrime.Text = EightBitNumberToHex(Z80.aPrime) & EightBitNumberToHex(Z80.fPrime)
	lblBCPrime.Text = EightBitNumberToHex(Z80.bPrime) & EightBitNumberToHex(Z80.cPrime)	
	lblDEPrime.Text = EightBitNumberToHex(Z80.dPrime) & EightBitNumberToHex(Z80.ePrime)
	lblHLPrime.Text = EightBitNumberToHex(Z80.hPrime) & EightBitNumberToHex(Z80.lPrime)
	lblIX.Text = SixteenBitNumberToHex(Z80.IX)
	lblIY.Text = SixteenBitNumberToHex(Z80.IY)
	lblFlags.text = Z80.CarryFlag & Z80.ZeroFlag & Z80.Parity_OverflowFlag & Z80.SignFlag & Z80.SubstractFlag &Z80.HalfCarryFlag
	lblFlagsPrime.Text = Z80.CarryFlagPrime & Z80.ZeroFlagPrime & Z80.Parity_OverflowFlagPrime & Z80.SignFlagPrime & Z80.SubstractFlagPrime &Z80.HalfCarryFlagPrime
	lblI.Text = EightBitNumberToHex(Z80.i)
	lblR.Text = EightBitNumberToHex(Z80.r)
	lblIM.Text = Z80.InterruptMode
	lblInterruptEnabled.text = "IE: " & Z80.InterruptEnabled
	lblOpCode.Text = EightBitNumberToHex(Z80.OpCode)
	lblOpName.Text = Z80.OpName
	lblOpCodePlus1.Text = EightBitNumberToHex(Memory.Read(Z80.PC_Old + 1))
	lblOpCodePlus2.Text = EightBitNumberToHex(Memory.Read(Z80.PC_Old + 2))
	lblInspectMemory0.Text = InspectFrom
	lblInspectMemory1.Text = InspectFrom + 1
	lblInspectMemory2.Text = InspectFrom + 2
	lblInspectMemory3.Text = InspectFrom + 3
	lblInspectMemory4.Text = InspectFrom + 4
	lblInspectMemory5.Text = InspectFrom + 5
	lblInspectMemory6.Text = InspectFrom + 6
	lblInspectMemory7.Text = InspectFrom + 7
	lblInspectMemory8.Text = InspectFrom + 8
	lblInspectMemory9.Text = InspectFrom + 9
	If InspectFrom >= 0 AND InspectFrom <= 65535 Then lblMemory0.Text = EightBitNumberToHex(Memory.Read(InspectFrom)) Else lblMemory0.Text = "-"
	If InspectFrom + 1 >= 0 AND InspectFrom + 1 <= 65535 Then lblMemory1.Text = EightBitNumberToHex(Memory.Read(InspectFrom + 1)) Else lblMemory1.Text = "-"
	If InspectFrom + 2 >= 0 AND InspectFrom + 2 <= 65535 Then lblMemory2.Text = EightBitNumberToHex(Memory.Read(InspectFrom + 2)) Else lblMemory2.Text = "-"
	If InspectFrom + 3 >= 0 AND InspectFrom + 3 <= 65535 Then lblMemory3.Text = EightBitNumberToHex(Memory.Read(InspectFrom + 3)) Else lblMemory3.Text = "-"
	If InspectFrom + 4 >= 0 AND InspectFrom + 4 <= 65535 Then lblMemory4.Text = EightBitNumberToHex(Memory.Read(InspectFrom + 4)) Else lblMemory4.Text = "-"
	If InspectFrom + 5 >= 0 AND InspectFrom + 5 <= 65535 Then lblMemory5.Text = EightBitNumberToHex(Memory.Read(InspectFrom + 5)) Else lblMemory5.Text = "-"
	If InspectFrom + 6 >= 0 AND InspectFrom + 6 <= 65535 Then lblMemory6.Text = EightBitNumberToHex(Memory.Read(InspectFrom + 6)) Else lblMemory6.Text = "-"
	If InspectFrom + 7 >= 0 AND InspectFrom + 7 <= 65535 Then lblMemory7.Text = EightBitNumberToHex(Memory.Read(InspectFrom + 7)) Else lblMemory7.Text = "-"
	If InspectFrom + 8 >= 0 AND InspectFrom + 8 <= 65535 Then lblMemory8.Text = EightBitNumberToHex(Memory.Read(InspectFrom + 8)) Else lblMemory8.Text = "-"
	If InspectFrom + 9 >= 0 AND InspectFrom + 9 <= 65535 Then lblMemory9.Text = EightBitNumberToHex(Memory.Read(InspectFrom + 9)) Else lblMemory9.Text = "-"
	Dim FlagsSummary As String
	If Z80.SignFlag = 1 Then
		FlagsSummary = FlagsSummary & "S"
	Else 
		FlagsSummary = FlagsSummary & "-"
	End If
	If Z80.ZeroFlag = 1 Then
		FlagsSummary = FlagsSummary & "Z"
	Else 
		FlagsSummary = FlagsSummary & "-"
	End If
	If Z80.HalfCarryFlag = 1 Then
		FlagsSummary = FlagsSummary & "H"
	Else 
		FlagsSummary = FlagsSummary & "-"
	End If
	If Z80.Parity_OverflowFlag = 1 Then
		FlagsSummary = FlagsSummary & "P"
	Else 
		FlagsSummary = FlagsSummary & "-"
	End If
	If Z80.SubstractFlag = 1 Then
		FlagsSummary = FlagsSummary & "N"
	Else 
		FlagsSummary = FlagsSummary & "-"
	End If
	If Z80.CarryFlag = 1 Then
		FlagsSummary = FlagsSummary & "C"
	Else 
		FlagsSummary = FlagsSummary & "-"
	End If
	lblFlags.Text = FlagsSummary
	Dim FlagsSummaryPrime As String
	If Z80.SignFlagPrime = 1 Then
		FlagsSummaryPrime = FlagsSummaryPrime & "S"
	Else 
		FlagsSummaryPrime = FlagsSummaryPrime & "-"
	End If
	If Z80.ZeroFlagPrime = 1 Then
		FlagsSummaryPrime = FlagsSummaryPrime & "Z"
	Else 
		FlagsSummaryPrime = FlagsSummaryPrime & "-"
	End If
	If Z80.HalfCarryFlagPrime = 1 Then
		FlagsSummaryPrime = FlagsSummaryPrime & "H"
	Else 
		FlagsSummaryPrime = FlagsSummaryPrime & "-"
	End If
	If Z80.Parity_OverflowFlagPrime = 1 Then
		FlagsSummaryPrime = FlagsSummaryPrime & "P"
	Else 
		FlagsSummaryPrime = FlagsSummaryPrime & "-"
	End If
	If Z80.SubstractFlagPrime = 1 Then
		FlagsSummaryPrime = FlagsSummaryPrime & "N"
	Else 
		FlagsSummaryPrime = FlagsSummaryPrime & "-"
	End If
	If Z80.CarryFlagPrime = 1 Then
		FlagsSummaryPrime = FlagsSummaryPrime & "C"
	Else 
		FlagsSummaryPrime = FlagsSummaryPrime & "-"
	End If
	lblFlagsPrime.Text = FlagsSummaryPrime
End Sub
Sub EightBitNumberToHex(p1 As Int) As String
	Dim HexString As String
	HexString = Bit.ToHexString(p1).ToUpperCase
	If HexString.Length = 0 Then
		HexString = "00"
	Else
		If HexString.Length = 1 Then HexString = "0" & HexString
	End If
	Return HexString
End Sub
Sub SixteenBitNumberToHex(p1 As Int) As String
	Dim HexString As String
	HexString = Bit.ToHexString(p1).ToUpperCase
	Select HexString.Length
		Case 0
			HexString = "0000"
		Case 1
			HexString = "000" & HexString
		Case 2
			HexString = "00" & HexString
		Case 3
			HexString = "0" & HexString
	End Select
	Return HexString
End Sub
Sub btnRefreshData_Action
	Dim InspectFromString As String
	Dim InspectFromHex As String
	InspectFromString = txtInspectFrom.Text
	Try
		If InspectFromString.StartsWith("0x") Then 'Hex input
			InspectFromHex = InspectFromString.Replace("0x","")
			InspectFrom = Bit.ParseInt(InspectFromHex,16)
		Else
			InspectFrom = InspectFromString
		End If
	Catch
		txtInspectFrom.Text = "Invalid"
	End Try
	Refresh
End Sub

Sub btnPause_Action
	If Main.MainTimer.Enabled = True Then
		Main.MainTimer.Enabled = False
		btnPause.Text = "Resume"
	Else
		Z80.Break = False
		Main.MainTimer.Enabled = True
		btnPause.Text = "Pause"
	End If
End Sub
Sub btnStep_Action
	Z80.InterpretInstruction
	Display.Refresh(OutPort.BorderColor)
	Refresh
End Sub
Sub btnBreakpoint_Action
	Dim BreakPointString As String
	Dim BreakPointHex As String
	BreakPointString = txtBreakpoint.text
	If ActiveBreakPoint = False Then
		Try
		If BreakPointString.StartsWith("0x") Then 'Hex input
			BreakPointHex = BreakPointString.Replace("0x","")
			BreakPoint = Bit.ParseInt(BreakPointHex,16)
		Else
			BreakPoint = BreakPointString
		End If
		btnBreakpoint.Text = "Deactivate Breakpoint"
		txtBreakpoint.Style = "-fx-background-color: salmon;"
		ActiveBreakPoint = True
		Catch
			txtBreakpoint.Text = "Invalid"
		End Try
	Else
		btnBreakpoint.Text = "Activate Breakpoint"
		ActiveBreakPoint = False
		BreakPoint = -1
		txtBreakpoint.Style = "-fx-background-color: white;"
	End If
End Sub
Sub btnRefreshScreen_Action
	Display.Refresh(OutPort.BorderColor)
	Refresh
End Sub
Sub btnInterruptToggle_Action
	If Z80.AllowInterrupt = True Then
		Z80.AllowInterrupt = False
		btnInterruptToggle.Text = "Accept interrupts"
	Else
		Z80.AllowInterrupt = True
		btnInterruptToggle.Text = "Ignore interrupts"
	End If
End Sub