﻿Type=StaticCode
Version=2.5
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Static code module
Private Sub Process_Globals
	Private fx As JFX
'	Dim canSpecScreen As Canvas
	Private jcan,jgc,jwri,jpxw As JavaObject
	Private Const ScreenMemoryAddress As Int = 16384 'Start of screen data in RAM.
	Private Const AttributeMemoryAddress As Int = 22528 'Start of attribute data in RAM.
	Private Const NormalColorValue As Int = 220 'Normal color value
	Private Const BrightColorValue As Int = 255 'Bright color value
	Private Col As Int
	Private ColorValue As Int
	Private PixelByte, AttributeByte As Byte 'The actual screen data (pixels and attributes).
	Private BgG,BgR,BgB,FgG,FgR,FgB  As Int
	Private ScanLine, Row, Section As Int
	Private xpos,ypos As Int
	Private SectionOffsetForPixels, SectionOffsetForAttributes, ScanLineOffset, PixelOffset, AttributeOffset As Int
	Private BitIndex As Int
	Private FlashCounter,FlashToggle As Int 'TODO: Handle FlashToggle more efficiently.
End Sub
Public Sub Initialize
	jcan = Main.canSpecScreen
	jgc = jcan.RunMethod("getGraphicsContext2D",Null)
	jwri.InitializeNewInstance("javafx.scene.image.WritableImage",Array(257,193))
	jpxw = jwri.RunMethod("getPixelWriter",Null)
	FlashCounter = 0
End Sub
Public Sub Refresh(p1 As Int)
	'Border
	Dim R,G,B As Int
	G = Bit.AND(p1,4) * 220 / 4
	R = Bit.AND(p1,2) * 220 / 2
	B = Bit.AND(p1,1) * 220
	jgc.RunMethod("setFill", Array(fx.Colors.RGB(R,G,B)))
	jgc.RunMethod("fillRect", Array(0.0,0.0,704.0,592.0))
	'Screen
	jgc.RunMethod("drawImage", Array(jwri,95.0,95.0,512.0,384.0)) 'Draw the image array to the canvas
End Sub
Public Sub UpdateImage
	' The screen is split into three 2k pages starting at memory location 16384.
	' The Screen is written to / read from in bytes.
	' Each byte represents a single line in screen space.
	' So the byte at 16384 (the start of screen memory) represents
	' the first 8 pixels from left yo right of screen space,
	' 16385 is the next 8 pixels and so on.
	' Screen size:  0-31, 0-23 = 256 x 192 px.
	'Counting from least to most significant bit,
	'an attribute byte dedicates three bits for the foreground color, 
	'three bits for the background color, one bit for the bright flag, 
	'and one bit for the flashing effect
	'0=Black, 1=Blue, 2=Red, 3=Magenta, 4=Green, 5=Yellow, 6=Cyan, 7=White
	
	' The ZX Spectrum produces the FLASH attribute mode by toggling the INK and PAPER bits once every 32 display frames.
	' This Is an extremely simple mode To implement, As the following equation shows:
	' DisplayPixelOut = DisplayPixel XOR ( AttributeFlash • Frame0-31 )
	
	FlashCounter = FlashCounter + 1
	If FlashCounter > 31 Then
		If FlashToggle = 1 Then FlashToggle = 0 Else FlashToggle = 1
		FlashCounter = 0
	End If
	For Section = 0 To 2
		SectionOffsetForPixels = ScreenMemoryAddress + Section * 2048
		SectionOffsetForAttributes = AttributeMemoryAddress + Section * 256
		For ScanLine = 0 To 7
			ScanLineOffset = ScanLine * 8
			For Row = 0 To 7
				PixelOffset = SectionOffsetForPixels + 32 * (ScanLineOffset + Row)
				AttributeOffset = SectionOffsetForAttributes + 32 * Row
				For Col = 0 To 31
					PixelByte = Memory.Read(PixelOffset + Col)
					AttributeByte = Memory.Read(AttributeOffset + Col)
					If Bit.AND(AttributeByte,64) = 64 Then ColorValue = BrightColorValue Else ColorValue = NormalColorValue
					If Bit.AND(AttributeByte,128) = 128 AND FlashToggle = 1 Then 'FLASH
						BgG = Bit.AND(AttributeByte,4) * ColorValue / 4
						BgR = Bit.AND(AttributeByte,2) * ColorValue / 2
						BgB = Bit.AND(AttributeByte,1) * ColorValue

						FgG = Bit.AND(AttributeByte,32) * ColorValue / 32
						FgR = Bit.AND(AttributeByte,16) * ColorValue / 16
						FgB = Bit.AND(AttributeByte,8) * ColorValue / 8
					Else
						FgG = Bit.AND(AttributeByte,4) * ColorValue / 4
						FgR = Bit.AND(AttributeByte,2) * ColorValue / 2
						FgB = Bit.AND(AttributeByte,1) * ColorValue

						BgG = Bit.AND(AttributeByte,32) * ColorValue / 32
						BgR = Bit.AND(AttributeByte,16) * ColorValue / 16
						BgB = Bit.AND(AttributeByte,8) * ColorValue / 8
					End If
					For BitIndex = 0 To 7
						xpos = 1 + BitIndex + 8 * Col
						ypos = 1 + ScanLine + Row * 8 + Section * 64
						If Bit.AND(128,Bit.ShiftLeft(PixelByte,BitIndex)) = 128 Then
							jpxw.RunMethod("setColor", Array(xpos,ypos,fx.Colors.RGB(FgR,FgG,FgB)))
						Else
							jpxw.RunMethod("setColor", Array(xpos,ypos,fx.Colors.RGB(BgR,BgG,BgB)))
						End If
					Next
				Next
			Next
		Next
	Next
End Sub
