﻿Type=StaticCode
Version=2.5
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'This module contains functions for memory read/write.
Private Sub Process_Globals
	Private fx As JFX
	Dim InternalMemory(66536) As Int
End Sub

'Return 8 bit content of a memory address.
Public Sub Read(Position As Int) As Int
	Return InternalMemory(Position)
End Sub

'Return 16 bit content of a memory address.
Public Sub Read16(Position As Int) As Int
	Return InternalMemory(Position) + 256 * InternalMemory(Position + 1)
End Sub

'Write to RAM.
Public Sub Write(Position As Int, Data As Int)
	If Position > 0x3FFF Then 'Don't write to ROM
		InternalMemory(Position) = Data
	End If
End Sub

'Write a block of bytes to memory.
Public Sub WriteByteBlock(StartPosition As Int, Data() As Byte)
	Dim Position As Int
	Position = StartPosition
	For i = 1 To Data.Length
		InternalMemory(Position) = Bit.AND(Data(i - 1),0xFF)
		Position = Position + 1
	Next
End Sub